package blusunrize.immersiveengineering.common.gui;

import blusunrize.immersiveengineering.common.util.Utils;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.ClickType;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;

public class ContainerIEBase<T extends TileEntity> extends Container
{
	public T tile;
	public IInventory inv;
	public int slotCount;

	public ContainerIEBase(InventoryPlayer inventoryPlayer, T tile)
	{
		this.tile=tile;
		this.inv = new InventoryTile(tile);
	}

	@Override
	public boolean func_75145_c(EntityPlayer player)
	{
		return inv.func_70300_a(player);
	}

	@Override
	public ItemStack func_184996_a(int id, int button, ClickType clickType, EntityPlayer player)
	{
		Slot slot = id<0?null: this.field_75151_b.get(id);
		if(!(slot instanceof IESlot.Ghost))
			return super.func_184996_a(id, button, clickType, player);
		//Spooky Ghost Slots!!!!
		ItemStack stack = null;
		ItemStack stackSlot = slot.func_75211_c();
		if(stackSlot!=null)
			stack = stackSlot.func_77946_l();

		if (button==2)
			slot.func_75215_d(null);
		else if(button==0||button==1)
		{
			InventoryPlayer playerInv = player.field_71071_by;
			ItemStack stackHeld = playerInv.func_70445_o();
			if (stackSlot == null)
			{
				if(stackHeld != null && slot.func_75214_a(stackHeld))
				{
					slot.func_75215_d(Utils.copyStackWithAmount(stackHeld, 1));
				}
			}
			else if (stackHeld == null)
			{
				slot.func_75215_d(null);
			}
			else if (slot.func_75214_a(stackHeld))
			{
				slot.func_75215_d(Utils.copyStackWithAmount(stackHeld, 1));
			}
		}
		else if (button == 5)
		{
			InventoryPlayer playerInv = player.field_71071_by;
			ItemStack stackHeld = playerInv.func_70445_o();
			if (!slot.func_75216_d())
			{
				slot.func_75215_d(Utils.copyStackWithAmount(stackHeld, 1));
			}
		}
		return stack;
	}

	@Override
	public ItemStack func_82846_b(EntityPlayer player, int slot)
	{
		ItemStack stack = null;
		Slot slotObject = field_75151_b.get(slot);

		if(slotObject != null && slotObject.func_75216_d())
		{
			ItemStack stackInSlot = slotObject.func_75211_c();
			stack = stackInSlot.func_77946_l();

			if(slot < slotCount)
			{
				if(!this.func_75135_a(stackInSlot, slotCount, (slotCount + 36), true))
					return null;
			}
			else
			{
				boolean b = false;
				for(int i=0;i<slotCount;i++)
					if(this.func_75139_a(i).func_75214_a(stackInSlot))
						if(this.func_75135_a(stackInSlot, i,i+1, false))
						{
							b = true;
							break;
						}
				if(!b)
					return null;
			}

			if(stackInSlot.field_77994_a == 0)
				slotObject.func_75215_d(null);
			else
				slotObject.func_75218_e();

			if(stackInSlot.field_77994_a == stack.field_77994_a)
				return null;
			slotObject.func_82870_a(player, stackInSlot);
		}
		return stack;
	}

	@Override
	protected boolean func_75135_a(ItemStack stack, int startIndex, int endIndex, boolean reverseDirection)
	{
		boolean flag = false;
		int i = startIndex;

		if(reverseDirection)
			i = endIndex - 1;

		if(stack.func_77985_e())
		{
			while(stack.field_77994_a > 0 && (!reverseDirection && i<endIndex || reverseDirection && i>=startIndex))
			{
				Slot slot = this.field_75151_b.get(i);
				ItemStack stackInSlot = slot.func_75211_c();

				if(stackInSlot!=null && areItemStacksEqual(stack, stackInSlot))
				{
					int j = stackInSlot.field_77994_a+stack.field_77994_a;
					int maxSize = Math.min(slot.func_75219_a(), stack.func_77976_d());
					if(j<=maxSize)
					{
						stack.field_77994_a = 0;
						stackInSlot.field_77994_a = j;
						slot.func_75218_e();
						flag = true;
					}
					else if(stackInSlot.field_77994_a<maxSize)
					{
						stack.field_77994_a -= (maxSize-stackInSlot.field_77994_a);
						stackInSlot.field_77994_a = maxSize;
						slot.func_75218_e();
					}
				}

				if(reverseDirection)
					--i;
				else
					++i;
			}
		}

		if(stack.field_77994_a > 0)
		{
			if(reverseDirection)
				i = endIndex - 1;
			else
				i = startIndex;

			while(!reverseDirection && i<endIndex || reverseDirection && i>=startIndex)
			{
				Slot slot = this.field_75151_b.get(i);
				ItemStack stackInSlot = slot.func_75211_c();
				if(stackInSlot==null && slot.func_75214_a(stack))
				{
					int maxSize = Math.min(slot.func_75219_a(), stack.func_77976_d());
					if(stack.field_77994_a<=maxSize)
					{
						slot.func_75215_d(stack.func_77946_l());
						slot.func_75218_e();
						stack.field_77994_a = 0;
						flag = true;
						break;
					}
					else
					{
						slot.func_75215_d(Utils.copyStackWithAmount(stack, maxSize));
						slot.func_75218_e();
						stack.field_77994_a -= maxSize;
					}
				}
				if(reverseDirection)
					--i;
				else
					++i;
			}
		}
		return flag;
	}

	private static boolean areItemStacksEqual(ItemStack stackA, ItemStack stackB)
	{
		return stackB.func_77973_b() == stackA.func_77973_b() && (!stackA.func_77981_g() || stackA.func_77960_j() == stackB.func_77960_j()) && ItemStack.func_77970_a(stackA, stackB);
	}

	@Override
	public void func_75134_a(EntityPlayer playerIn)
	{
		super.func_75134_a(playerIn);
		this.inv.func_174886_c(playerIn);
	}
}
