package blusunrize.immersiveengineering.common.gui;

import blusunrize.immersiveengineering.api.tool.IInternalStorageItem;
import blusunrize.immersiveengineering.common.util.Utils;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.*;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;

public abstract class ContainerInternalStorageItem extends Container
{
	protected World worldObj;
	protected int blockedSlot;
	public IInventory input;
	protected EntityEquipmentSlot equipmentSlot = null;
	protected ItemStack heldItem = null;
	protected EntityPlayer player = null;
	public final int internalSlots;

	public ContainerInternalStorageItem(InventoryPlayer iinventory, World world, EntityEquipmentSlot entityEquipmentSlot, ItemStack heldItem)
	{
		this.worldObj = world;
		this.player = iinventory.field_70458_d;
		this.equipmentSlot = entityEquipmentSlot;
		this.heldItem = heldItem;
		this.input = new InventoryStorageItem(this, heldItem);
		this.internalSlots = this.addSlots(iinventory);
		this.blockedSlot = (iinventory.field_70461_c + 27 + internalSlots);


		if (!world.field_72995_K)
			try {
				((InventoryStorageItem)this.input).stackList = ((IInternalStorageItem)this.heldItem.func_77973_b()).getContainedItems(this.heldItem);
			} catch(Exception e)
			{
				e.printStackTrace();
			}
		this.func_75130_a(this.input);
	}

	abstract int addSlots(InventoryPlayer iinventory);

	@Override
	public ItemStack func_82846_b(EntityPlayer par1EntityPlayer, int slot)
	{
		ItemStack stack = null;
		Slot slotObject = field_75151_b.get(slot);

		if(slotObject != null && slotObject.func_75216_d())
		{
			ItemStack stackInSlot = slotObject.func_75211_c();
			stack = stackInSlot.func_77946_l();

			if(slot < internalSlots)
			{
				if(!this.func_75135_a(stackInSlot, internalSlots, (internalSlots + 36), true))
					return null;
			}
			else if(stackInSlot!=null)
			{
				boolean b = true;
				for(int i=0; i<internalSlots; i++)
				{
					Slot s = field_75151_b.get(i);
					if(s!=null && s.func_75214_a(stackInSlot))
					{
						if(s.func_75211_c()!=null && (!ItemStack.func_179545_c(stackInSlot,s.func_75211_c()) || !Utils.compareItemNBT(stackInSlot,s.func_75211_c())) )
							continue;
						int space = Math.min(s.func_178170_b(stackInSlot), stackInSlot.func_77976_d());
						if(s.func_75211_c() != null)
							space -= s.func_75211_c().field_77994_a;
						if(space <= 0)
							continue;
						ItemStack insert = stackInSlot;
						if(space < stackInSlot.field_77994_a)
							insert = stackInSlot.func_77979_a(space);
						if(this.func_75135_a(insert, i, i + 1, true))
						{
							b = false;
							break;
						} else
							continue;
					}
				}
				if(b)
					return null;
			}

			if (stackInSlot.field_77994_a == 0)
				slotObject.func_75215_d(null);
			else
				slotObject.func_75218_e();

			if (stackInSlot.field_77994_a == stack.field_77994_a)
				return null;
			slotObject.func_82870_a(player, stack);
			updatePlayerItem();
		}
		return stack;
	}

	@Override
	public boolean func_75145_c(EntityPlayer entityplayer)
	{
		return true;
	}

	@Override
	public ItemStack func_184996_a(int par1, int par2, ClickType par3, EntityPlayer par4EntityPlayer)
	{
		if(par1 == this.blockedSlot || (par3== ClickType.SWAP&&par2==par4EntityPlayer.field_71071_by.field_70461_c))
			return null;
		ItemStack ret = super.func_184996_a(par1, par2, par3, par4EntityPlayer);
		updatePlayerItem();
		return ret;
	}

	@Override
	public void func_75134_a(EntityPlayer par1EntityPlayer)
	{
		super.func_75134_a(par1EntityPlayer);
		if (!this.worldObj.field_72995_K)
			updatePlayerItem();
	}

	protected void updatePlayerItem()
	{
		((IInternalStorageItem)this.heldItem.func_77973_b()).setContainedItems(this.heldItem, ((InventoryStorageItem)this.input).stackList);
		ItemStack hand = player.func_184582_a(this.equipmentSlot);
		if(hand != null && !hand.equals(heldItem))
			player.func_184201_a(this.equipmentSlot, this.heldItem);
		player.field_71071_by.func_70296_d();
	}
}
